﻿package {
	import flash.display.MovieClip;
	import flash.events.Event;
	public class Main extends MovieClip {
		private var p1:Polygon;
		private var p2:Polygon;
		public function Main():void {
			trace("Hauptprogramm gestartet");
			p1 = new Polygon();
			p1.position = new MyVector(200,200);
			p1.addStroke(100,20);
			p1.addStroke(10,80);
			p1.addStroke(-50,0);
			p1.close();
			p2 = new Polygon();
			p2.addStroke(20,0);
			p2.addStroke(0,20);
			p2.close();
			addEventListener(Event.ENTER_FRAME, enterFrameHandler);
		}
		
		public function projectPoly(p:Polygon, pv:MyVector):Array {
			var s:Number=NaN;
			var e:Number=NaN;
			var curV:MyVector = p.position;
			pv = pv.normalize();
			for (var i=0;i<p.vectors.length;i++) {
				var s1:Number = curV.dotProduct(pv);
				var e1:Number = p.vectors[i].dotProduct(pv);
				if (isNaN(s)) s = s1;
				if (isNaN(e)) e = s1+e1;
				if (s1<s) s=s1;
				if (s1+e1>e) {
					e=s1+e1;
//					trace("hier");
				}
				curV = curV.add(p.vectors[i]);
			}
			drawVector(pv.mult(s).add(new MyVector(200,200)),pv.mult(e).add(new MyVector(200,200)),3);
			return [s,e];
			//trace("Projection is from "+s+" to "+e);
		}
		
		public function hitTest(a:Array, b:Array):Boolean {
			var i0:Boolean = (b[0]>a[0] && b[0]<a[1]);
			var i1:Boolean = (b[1]>a[0] && b[1]<a[1]);
			return i0 || i1; 			
		}
		
		public function drawVector(pv:MyVector, v:MyVector, lineWidth:int):void {
			graphics.lineStyle(lineWidth);
			//trace(pv.x, pv.y);
			graphics.moveTo(pv.x, pv.y);
			graphics.lineTo(v.x, v.y);
		}
		
		public function enterFrameHandler(evt:Event):void {
			p2.position = new MyVector(mouseX, mouseY);
			graphics.clear();
			if (polygonHit(p1,p2)) {
				trace("überschneidung");
			} else {
				trace("keine überschneidung");
			}
			drawPoly(p1);
			drawPoly(p2);
		}
		
		private function polygonHit(p1:Polygon, p2:Polygon):Boolean  {
			var projectionVector:MyVector;
			for (var i:int=0;i<p1.vectors.length;i++) {
				projectionVector = p1.vectors[i].normal();
				if (!hitTest(projectPoly(p1,projectionVector),projectPoly(p2,projectionVector))) {
					return false;
				}
																							  
			}
			for (var i:int=0;i<p2.vectors.length;i++) {
				projectionVector = p2.vectors[i].normal();
				if (!hitTest(projectPoly(p1,projectionVector),projectPoly(p2,projectionVector))) {
					return false;
				}
																							  
			}
			return true;
		}
		
		private function drawPoly(p:Polygon):void {
			graphics.lineStyle(p.strokeWidth,p.color);
			var curX:Number = p.position.x;
			var curY:Number = p.position.y;
			graphics.moveTo(curX,curY);
			for (var i:int=0;i<p.vectors.length;i++) {
				curX += p.vectors[i].x;
				curY += p.vectors[i].y;
				graphics.lineTo(curX,curY);
			}
		}
	}
}